import { EditorPluginProps, EditorPlugin } from '@edtr-io/plugin';
import * as React from 'react';
import { HighlightRendererProps } from './renderer';
/** @public */
export declare const highlightState: import("@edtr-io/internal__plugin-state").StateType<import("@edtr-io/internal__plugin-state").StateTypesSerializedType<{
    code: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    showLineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>, import("@edtr-io/internal__plugin-state").StateTypesValueType<{
    code: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    showLineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>, import("@edtr-io/internal__plugin-state").StateTypesReturnType<{
    code: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    language: import("@edtr-io/internal__plugin-state").StateType<string, string, {
        value: string;
        get(): string;
        set(value: string | ((currentValue: string) => string)): void;
    }>;
    showLineNumbers: import("@edtr-io/internal__plugin-state").StateType<boolean, boolean, {
        value: boolean;
        get(): boolean;
        set(value: boolean | ((currentValue: boolean) => boolean)): void;
    }>;
}>>;
/** @public */
export declare type HighlightState = typeof highlightState;
/** @public */
export interface HighlightConfig {
    Renderer: React.ComponentType<HighlightRendererProps>;
}
/** @public */
export declare type HighlightProps = EditorPluginProps<HighlightState, HighlightConfig>;
/**
 * @param config - {@link HighlightConfig | Plugin configuration}
 * @public
 */
export declare function createHighlightPlugin(config?: HighlightConfig): EditorPlugin<HighlightState, HighlightConfig>;
export { HighlightRendererProps };
//# sourceMappingURL=index.d.ts.map